#!/usr/bin/env python3

import subprocess
import os
from time import sleep, time

def main():
    """The main function which will combine all the different steps of running the deployment."""
    cert_manager_definitions = build_k8s_definitions(kustomize_path=os.path.abspath("k8s/cert-manager"), output_file="cert-manager.yaml")
    apply_kubernetes_definitions(kubernetes_definitions_path=cert_manager_definitions)

    wait_for_cert_manager_ready_status()

    issuer_definitions_path = build_k8s_definitions(kustomize_path=os.path.abspath("k8s/issuer"), output_file="issuer.yaml")
    apply_kubernetes_definitions(kubernetes_definitions_path=issuer_definitions_path)


class TimeoutException(Exception):
    pass

def wait_for_cert_manager_ready_status():
    five_min_in_secs = 60 * 5
    sleep_secs = 10
    start_time = time()
    current_time = start_time
    while not cert_manager_ready():
        if current_time - start_time > five_min_in_secs:
            raise TimeoutException("Timed out waiting for the cert-manager to be ready")
        sleep(sleep_secs)
        current_time = time()

def cert_manager_ready() -> bool:
    result = subprocess.run(["./cmctl", "check", "api"])
    return result.returncode == 0

def build_k8s_definitions(kustomize_path: str, output_file: str) -> str:
    """Sets up the deployment by building the kustomize definition using given kustomize_path."""
    print(f"Running kustomize at {kustomize_path}")
    print(f"Setting up deployment by running kustomize and placing result in the working directory")

    kustomize_build_result = subprocess.run(["kustomize", "build", "."], cwd=kustomize_path, capture_output=True, check=True, encoding="utf-8")
    contents = kustomize_build_result.stdout

    with open(output_file, "w") as f:
        f.write(contents)

    return output_file

def apply_kubernetes_definitions(kubernetes_definitions_path: str):
    """Actually perform the apply of the kubernetes definitions built from kustomize.

    :param kubernetes_definitions_path: The path to the kubernetes definitions file that was generated by kustomize.
    :type kubernetes_definitions_path: str
    """

    print("Running kubernetes apply.")
    cmd = ["kubectl", "apply", "-f", kubernetes_definitions_path]
    subprocess.run(cmd, check=True, encoding="utf-8")

if __name__ == "__main__":
    main()
